#ifndef ns_tcpdtn_h
#define ns_tcpdtn_h

#include "tcp.h"
#include "dtn.h"

class BundleManagerTCP {

public:
	BundleManagerTCP();
	~BundleManagerTCP();
	
	void		AddBundle(Bundle newBundle); // Add bundle segment to the queue
	Bundle*		GetBundle(int nSequenceNo);
	Bundle*		FindFirstBundle(Bundle inBundle);
	void		Cleanup(int nUpToSequenceNo);
	void		EmptyList();
	int		BundlesStored();
	int		MemoryAllocated();
	void		DumpBundles();
	int		RemoveBundlesAndReorder(Bundle inBundle, int nMaxSeqNumber);
	void		DumpMinMaxSequence();
	
protected:
	Bundle		*pHead_;
};

class TcpDtnAgent : public TcpAgent {

public:
	TcpDtnAgent();
	virtual ~TcpDtnAgent();

	int			sendBundle(Bundle inBundle, int nBytes);
	void 			SetDTNAgent(DtnAgent *pDtnAgent) { m_pDtnAgent = pDtnAgent; }
	void			CancelBundleTransmission(Bundle inBundle);
	bool			BundleInTransit(Bundle inBundle);
protected:
	virtual void		output_helper(Packet *pPacket);
	virtual void 		recv_newack_helper(Packet *pPacket);

	DtnAgent 		*m_pDtnAgent;
	BundleManagerTCP	bundleManagerTCP_;
	int			lastSequenceNo_;
};

#endif
